/*Program : Kamus Inggris-Indonesia*/
/* File       : Kamus Bahasa Inggris */
/* Programmer : Irwan Hermanto */
/* Tanggal    : 26 November 2004  */

Domains
	indo,inggris=string

Database
	terjemah(inggris,indo)

Predicates
	terjemahkan
	terjemahkan2
	terjemahkan3(inggris)
	terus1(char)
	tambah_kata
	hapus
	hapus2
	pilihan_menu
	pilihan(char)
	daftar
	daftar2
	terus(char)
	hapusmk
	hapusmk1

Goal
	makewindow(1,21,2,"KAMUS INGGRIS-INDONESIA",0,0,25,80),
	makewindow(2,116,2,"KAMUS INGGRIS",10,5,12,25),
	makewindow(3,116,2,"INDONESIA",8,35,16,44),
	shiftwindow(1),pilihan_menu.

Clauses
	pilihan_menu:- 		/* Membuat file baru*/
		not(existfile("dbase11.dat")),
		assertz(terjemah(start,mulai)),save("dbase11.dat"),hapusmk,fail.
		
		
	pilihan_menu:-		/* Membuat file kerja*/
		cursor(3,5),
		write("Pilih salah satu : "),
		cursor(4,5),
		write("0.Keluar kamus : "),
		cursor(5,5),
		write("1.Menambah Perbendaharaan Kata : "),
		cursor(6,5),
		write("2.Menerjemahkan Kata : "),
		cursor(7,5),
		write("3.Menghapus Kata : "),
		cursor(8,5),
		write("4.Melihat Seluruh Kata : "),
		cursor(9,5),
		write("5.Untuk kembali ke Menu tekan 'q'"),
		cursor(10,5),
		consult("dbase11.dat"),
		readchar(Pilih),
		pilihan(Pilih).
	pilihan('1') :-      /* Menambah perbendaharaan kata*/
		tambah_kata.
	pilihan('2') :-
		terjemahkan.  /* Menambahkan kata */ 
	pilihan('3') :-		/* Menghapus Semua kata(record)*/
		hapus.
	pilihan('4') :-		/* Melihat seluruh kata */
		daftar.
	pilihan('0') :-		/* Keluar Program*/
		hapusmk1,
		exit.
	pilihan(_):-        	/* pilihan salah */
		beep,
		readchar(Pilih),
		pilihan(Pilih).

	hapusmk1:-  /*menghapus basis data pada memori internal komputer*/
		retract(terjemah(_,_)),
		fail.

	hapusmk1.

	tambah_kata:- /* Menambah perbendaharaan kata*/
		shiftwindow(2),
		readln(Inggris),
		shiftwindow(3),
		readln(Indo),
		assertz(terjemah(Inggris,Indo)),
		readchar(X),
		terus(X).
	
	terus ('q'):-
		deletefile("dbase11.dat"),
		save("dbase11.dat"),
		hapusmk.
	terus(_):-
		tambah_kata.
	terjemahkan:-		/*Menerjemahkan kata*/
		terjemahkan2.
	hapusmk:-
		retract(terjemah(_,_)),
		fail.
	hapusmk:-
		shiftwindow(1),
		pilihan_menu.
	terjemahkan2:-
		shiftwindow(2),clearwindow,
		readln(Inggris),
		shiftwindow(3),clearwindow,
		terjemahkan3(Inggris).
	terjemahkan2:-
		shiftwindow(3),clearwindow,
		write("Belum ada"),
		readchar(X),
		terus1(X).
	terjemahkan3(Inggris):-
		terjemah(Inggris,Indo),
		write(Indo),
		nl,fail.
	terjemahkan3(Inggris):-
		terjemah(Inggris,_),
		readchar(X),terus1(X).

	terus1('q'):-
		hapusmk.
	terus1(_):-
		shiftwindow(2),
		terjemahkan2.
	hapus:-
		shiftwindow(2),
		hapus2.
	hapus2:-
		readln(Inggris),
		retract(terjemah(Inggris,_)),fail.
	hapus2:-
		deletefile("dbase11.dat"),
		save("dbase11.dat"),
		hapusmk.
	daftar:-
		shiftwindow(2),clearwindow,
		shiftwindow(3),clearwindow,
		daftar2.
	daftar2:-
		terjemah(X,Y),
		shiftwindow(2),
		write(X),nl,
		shiftwindow(3),
		write(Y),nl,fail.
	daftar2:-
		write("Tekan apa saja untuk melanjutkan"),
		readchar(_),
		nl,hapusmk.