/* 
=============================================================================
	File       : PPT.pro
	Program    : Program Pengenal Teman
	Programmer : Alex Natanael           <1102019>
		     Jackson LM Simanungkalit <1102031>
        Tanggal    : 28 April 2004
        Deskripsi  : Program ini bisa mencari nama teman anda dengan masukan 
        	     sifat-sifatnya
=============================================================================
*/
		   
Domains
       nama,sifat = string
     
       
Database
       carii(sifat,nama)

Predicates
       menu_utama
       del
       pilihan(char)
       del1
       buat
       cari
       
       hapus
       bio
       lanjut(char)
       lanjut1(char)
       cari2 
       cari3(sifat) 
       hapus2
       bio2
      

Goal   makewindow(1,15,4, " PROGRAM PENGENAL TEMAN ",0,0,25,80),
       makewindow(2,116,4," Sifat ",11,6,12,25),
       makewindow(3,116,4," Nama  ",8,35,16,44),
       shiftwindow(1),menu_utama.

Clauses
       
       menu_utama:-
       not    (existfile("base3.dat")),
       assertz(carii(start,mulai)),
       save   ("base3.dat"),fail.
       
       menu_utama:-
       cursor(3,5),write(" 1 . Buat Data "),
       cursor(4,5),write(" 2 . Pencarian "),
       cursor(5,5),write(" 3 . Hapus Data "),
       cursor(6,5),write(" 4 . Biodata "),
       cursor(7,5),write(" x . Keluar Program "),
       cursor(9,5),write(" Pilihan: "),
       cursor(3,43),write(" kembali tekan b !!! "),
       cursor(10,5),consult ("base3.dat"),
       
       readchar(Plh),pilihan(Plh).
       
       pilihan('1'):-buat.
       pilihan('2'):-cari.
       pilihan('3'):-hapus.
       pilihan('4'):-bio.
       pilihan('x'):-del1,exit.
       pilihan (_) :-beep,readchar(Pilih),pilihan(Pilih).
       
       del1:-retract(carii (_,_)),fail.
       del1.
       
       buat:-
            shiftwindow(2),
            readln(Sifat),
            shiftwindow(3),
            readln(Nama),
            assertz(carii(Sifat,Nama)),
            readchar(X),lanjut(X).
       
       lanjut('b'):-deletefile("base3.dat"),
                    save      ("base3.dat"),del.
       lanjut(_):-buat.
       
       cari:-cari2.
       
       del:-retract(carii(_,_)),fail.
       del:-shiftwindow(1),menu_utama.
       
       cari2:-shiftwindow(2),clearwindow,
              write(" Sifat yang akan "),nl,
              write(" dicari ? "),
              readln(Sifat),
              shiftwindow(3),clearwindow,
              cari3(Sifat).
       cari2:-shiftwindow(2),clearwindow,
              write(" tidak ada "),nl,
              write(" tekan b untuk keluar ! "),
              readchar(X),lanjut1(X).
       cari3(Sifat):-carii(Sifat,Nama),write(Nama),nl,fail.
       cari3(Sifat):-carii(Sifat,_),readchar(X),lanjut1(X).
       
       lanjut1('b'):-del.
       lanjut1(_):-shiftwindow(2),cari2.
       
       hapus:-shiftwindow(2),hapus2.
       hapus2:-clearwindow,
              write(" Sifat yang akan "),nl,
              write(" dihapus ? "),
              readln(Sifat),retract(carii(Sifat,_)),fail.
       hapus2:-deletefile("base3.dat"),save("base3.dat"),del.
       
       bio:-shiftwindow(2),clearwindow,
            shiftwindow(3),clearwindow,
            bio2.
       bio2:-carii(X,Y),
             shiftwindow(2),write(X),nl,
             shiftwindow(3),write(Y),nl,fail.
       bio2:-write(" tekan apa saja !!! "),
       readchar(_),nl,del.
                                   